Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.lowagie.text.pdf
Class PdfPKCS7

    java.lang.Object
      com.lowagie.text.pdf.PdfPKCS7

    public class PdfPKCS7

extends Object

This class does all the processing related to signing and verifying a PKCS#7 signature.

It's based in code found at org.bouncycastle.

Nested Class Summary
`static class` | `PdfPKCS7.X509Name` a class that holds an X509 name
`static class` | `PdfPKCS7.X509NameTokenizer` class for breaking up an X500 Name into it's component tokens, ala java.util.StringTokenizer.

Field Summary
`private Collection` | `certs`
`private Collection` | `crls`
`private byte[]` | `digest`
`private String` | `digestAlgorithm`
`private Set` | `digestalgos`
`private byte[]` | `digestAttr`
`private String` | `digestEncryptionAlgorithm`
`private byte[]` | `externalDigest`
`private byte[]` | `externalRSAdata`
`private static String` | `ID_ADBE_REVOCATION`
`private static String` | `ID_CONTENT_TYPE`
`private static String` | `ID_DSA`
`private static String` | `ID_MD2`
`private static String` | `ID_MD2RSA`
`private static String` | `ID_MD5`
`private static String` | `ID_MD5RSA`
`private static String` | `ID_MESSAGE_DIGEST`
`private static String` | `ID_PKCS7_DATA`
`private static String` | `ID_PKCS7_SIGNED_DATA`
`private static String` | `ID_RSA`
`private static String` | `ID_SHA1`
`private static String` | `ID_SHA1RSA`
`private static String` | `ID_SIGNING_TIME`
`private String` | `location` Holds value of property location.
`private MessageDigest` | `messageDigest`
`private PrivateKey` | `privKey`
`private String` | `reason` Holds value of property reason.
`private byte[]` | `RSAdata`
`private Signature` | `sig`
`private byte[]` | `sigAttr`
`private X509Certificate` | `signCert`
`private Calendar` | `signDate` Holds value of property signDate.
`private int` | `signerversion`
`private String` | `signName` Holds value of property signName.
`private boolean` | `verified`
`private boolean` | `verifyResult`
`private int` | `version`

Constructor Summary
`PdfPKCS7(byte[] contentsKey, byte[] certsKey, String provider)` Verifies a signature using the sub-filter adbe.x509.rsa_sha1.
`PdfPKCS7(byte[] contentsKey, String provider)` Verifies a signature using the sub-filter adbe.pkcs7.detached or adbe.pkcs7.sha1.
`PdfPKCS7(PrivateKey privKey, Certificate[] certChain, CRL[] crlList, String hashAlgorithm, String provider, boolean hasRSAdata)` Generates a signature.

Method Summary
`byte[]` | `getAuthenticatedAttributeBytes(byte[] secondDigest, Calendar signingTime)` When using authenticatedAttributes the authentication process is different.
`Certificate[]` | `getCertificates()` Get the X.509 certificates associated with this PKCS#7 object
`Collection` | `getCRLs()` Get the X.509 certificate revocation lists associated with this PKCS#7 object
`String` | `getDigestAlgorithm()` Get the algorithm used to calculate the message digest
`byte[]` | `getEncodedPKCS1()` Gets the bytes for the PKCS#1 object.
`byte[]` | `getEncodedPKCS7()` Gets the bytes for the PKCS7SignedData object.
`byte[]` | `getEncodedPKCS7(byte[] secondDigest, Calendar signingTime)` Gets the bytes for the PKCS7SignedData object.
`String` | `getHashAlgorithm()` Returns the algorithm.
`private static DERObject` | `getIssuer(byte[] enc)` Get the "issuer" from the TBSCertificate bytes that are passed in
`static PdfPKCS7.X509Name` | `getIssuerFields(X509Certificate cert)` Get the issuer fields from an X509 Certificate
`String` | `getLocation()` Getter for property location.
`String` | `getReason()` Getter for property reason.
`Calendar` | `getSignDate()` Getter for property signDate.
`X509Certificate` | `getSigningCertificate()` Get the X.509 certificate actually used to sign the digest.
`int` | `getSigningInfoVersion()` Get the version of the PKCS#7 "SignerInfo" object.
`String` | `getSignName()` Getter for property sigName.
`private static DERObject` | `getSubject(byte[] enc)` Get the "subject" from the TBSCertificate bytes that are passed in
`static PdfPKCS7.X509Name` | `getSubjectFields(X509Certificate cert)` Get the subject fields from an X509 Certificate
`int` | `getVersion()` Get the version of the PKCS#7 object.
`static KeyStore` | `loadCacertsKeyStore()` Loads the default root certificates at <java.home>/lib/security/cacerts with the default provider.
`static KeyStore` | `loadCacertsKeyStore(String provider)` Loads the default root certificates at <java.home>/lib/security/cacerts.
`void` | `setExternalDigest(byte[] digest, byte[] RSAdata, String digestEncryptionAlgorithm)` Sets the digest/signature to an external calculated value.
`void` | `setLocation(String location)` Setter for property location.
`void` | `setReason(String reason)` Setter for property reason.
`void` | `setSignDate(Calendar signDate)` Setter for property signDate.
`void` | `setSignName(String signName)` Setter for property sigName.
`void` | `update(byte[] buf, int off, int len)` Update the digest with the specified bytes.
`boolean` | `verify()` Verify the digest.
`static String` | `verifyCertificate(X509Certificate cert, Collection crls, Calendar calendar)` Verifies a single certificate.
`static Object[]` | `verifyCertificates(Certificate[] certs, KeyStore keystore, Collection crls, Calendar calendar)` Verifies a certificate chain against a KeyStore.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### sigAttr

    private byte[] sigAttr

### digestAttr

    private byte[] digestAttr

### version

    private int version

### signerversion

    private int signerversion

### digestalgos

    private Set digestalgos

### certs

    private Collection certs

### crls

    private Collection crls

### signCert

    private X509Certificate signCert

### digest

    private byte[] digest

### messageDigest

    private MessageDigest messageDigest

### digestAlgorithm

    private String digestAlgorithm

### digestEncryptionAlgorithm

    private String digestEncryptionAlgorithm

### sig

    private Signature sig

### privKey

    private transient PrivateKey privKey

### RSAdata

    private byte[] RSAdata

### verified

    private boolean verified

### verifyResult

    private boolean verifyResult

### externalDigest

    private byte[] externalDigest

### externalRSAdata

    private byte[] externalRSAdata

### ID_PKCS7_DATA

    private static final String ID_PKCS7_DATA

See Also:
  Constant Field Values

### ID_PKCS7_SIGNED_DATA

    private static final String ID_PKCS7_SIGNED_DATA

See Also:
  Constant Field Values

### ID_MD5

    private static final String ID_MD5

See Also:
  Constant Field Values

### ID_MD2

    private static final String ID_MD2

See Also:
  Constant Field Values

### ID_SHA1

    private static final String ID_SHA1

See Also:
  Constant Field Values

### ID_RSA

    private static final String ID_RSA

See Also:
  Constant Field Values

### ID_DSA

    private static final String ID_DSA

See Also:
  Constant Field Values

### ID_CONTENT_TYPE

    private static final String ID_CONTENT_TYPE

See Also:
  Constant Field Values

### ID_MESSAGE_DIGEST

    private static final String ID_MESSAGE_DIGEST

See Also:
  Constant Field Values

### ID_SIGNING_TIME

    private static final String ID_SIGNING_TIME

See Also:
  Constant Field Values

### ID_MD2RSA

    private static final String ID_MD2RSA

See Also:
  Constant Field Values

### ID_MD5RSA

    private static final String ID_MD5RSA

See Also:
  Constant Field Values

### ID_SHA1RSA

    private static final String ID_SHA1RSA

See Also:
  Constant Field Values

### ID_ADBE_REVOCATION

    private static final String ID_ADBE_REVOCATION

See Also:
  Constant Field Values

### reason

    private String reason

  Holds value of property reason.

### location

    private String location

  Holds value of property location.

### signDate

    private Calendar signDate

  Holds value of property signDate.

### signName

    private String signName

  Holds value of property signName.

Constructor Detail

### PdfPKCS7

    public PdfPKCS7(byte[] contentsKey,
                    byte[] certsKey,
                    String provider)
             throws SecurityException,
                    InvalidKeyException,
                    CertificateException,
                    NoSuchProviderException,
                    NoSuchAlgorithmException,
                    IOException,
                    StreamParsingException

  Verifies a signature using the sub-filter adbe.x509.rsa_sha1.

  Parameters:
    `contentsKey` - the /Contents key
    `certsKey` - the /Cert key
    `provider` - the provider or `null` for the default provider
  Throws:
    `SecurityException` - on error
    `InvalidKeyException` - on error
    `CertificateException` - on error
    `NoSuchProviderException` - on error
    `NoSuchAlgorithmException` - on error
    `IOException` - on error
    `StreamParsingException`

### PdfPKCS7

    public PdfPKCS7(byte[] contentsKey,
                    String provider)
             throws SecurityException,
                    CRLException,
                    InvalidKeyException,
                    CertificateException,
                    NoSuchProviderException,
                    NoSuchAlgorithmException,
                    StreamParsingException

  Verifies a signature using the sub-filter adbe.pkcs7.detached or adbe.pkcs7.sha1.

  Parameters:
    `contentsKey` - the /Contents key
    `provider` - the provider or `null` for the default provider
  Throws:
    `SecurityException` - on error
    `CRLException` - on error
    `InvalidKeyException` - on error
    `CertificateException` - on error
    `NoSuchProviderException` - on error
    `NoSuchAlgorithmException` - on error
    `StreamParsingException`

### PdfPKCS7

    public PdfPKCS7(PrivateKey privKey,
                    Certificate[] certChain,
                    CRL[] crlList,
                    String hashAlgorithm,
                    String provider,
                    boolean hasRSAdata)
             throws SecurityException,
                    InvalidKeyException,
                    NoSuchProviderException,
                    NoSuchAlgorithmException

  Generates a signature.

  Parameters:
    `privKey` - the private key
    `certChain` - the certificate chain
    `crlList` - the certificate revocation list
    `hashAlgorithm` - the hash algorithm
    `provider` - the provider or `null` for the default provider
    `hasRSAdata` - `true` if the sub-filter is adbe.pkcs7.sha1
  Throws:
    `SecurityException` - on error
    `InvalidKeyException` - on error
    `NoSuchProviderException` - on error
    `NoSuchAlgorithmException` - on error

Method Detail

### update

    public void update(byte[] buf,
                       int off,
                       int len)
                throws SignatureException

  Update the digest with the specified bytes. This method is used both for signing and verifying

  Parameters:
    `buf` - the data buffer
    `off` - the offset in the data buffer
    `len` - the data length
  Throws:
    `SignatureException` - on error

### verify

    public boolean verify()
                   throws SignatureException

  Verify the digest.

  Returns:
    `true` if the signature checks out, `false` otherwise
  Throws:
    `SignatureException` - on error

### getCertificates

    public Certificate[] getCertificates()

  Get the X.509 certificates associated with this PKCS#7 object

  Returns:
    the X.509 certificates associated with this PKCS#7 object

### getCRLs

    public Collection getCRLs()

  Get the X.509 certificate revocation lists associated with this PKCS#7 object

  Returns:
    the X.509 certificate revocation lists associated with this PKCS#7 object

### getSigningCertificate

    public X509Certificate getSigningCertificate()

  Get the X.509 certificate actually used to sign the digest.

  Returns:
    the X.509 certificate actually used to sign the digest

### getVersion

    public int getVersion()

  Get the version of the PKCS#7 object. Always 1

  Returns:
    the version of the PKCS#7 object. Always 1

### getSigningInfoVersion

    public int getSigningInfoVersion()

  Get the version of the PKCS#7 "SignerInfo" object. Always 1

  Returns:
    the version of the PKCS#7 "SignerInfo" object. Always 1

### getDigestAlgorithm

    public String getDigestAlgorithm()

  Get the algorithm used to calculate the message digest

  Returns:
    the algorithm used to calculate the message digest

### getHashAlgorithm

    public String getHashAlgorithm()

  Returns the algorithm.

  Returns:
    the digest algorithm

### loadCacertsKeyStore

    public static KeyStore loadCacertsKeyStore()

  Loads the default root certificates at <java.home>/lib/security/cacerts with the default provider.

  Returns:
    a `KeyStore`

### loadCacertsKeyStore

    public static KeyStore loadCacertsKeyStore(String provider)

  Loads the default root certificates at <java.home>/lib/security/cacerts.

  Parameters:
    `provider` - the provider or `null` for the default provider
  Returns:
    a `KeyStore`

### verifyCertificate

    public static String verifyCertificate(X509Certificate cert,
                                           Collection crls,
                                           Calendar calendar)

  Verifies a single certificate.

  Parameters:
    `cert` - the certificate to verify
    `crls` - the certificate revocation list or `null`
    `calendar` - the date or `null` for the current date
  Returns:
    a `String` with the error description or `null` if no error

### verifyCertificates

    public static Object[] verifyCertificates(Certificate[] certs,
                                              KeyStore keystore,
                                              Collection crls,
                                              Calendar calendar)

  Verifies a certificate chain against a KeyStore.

  Parameters:
    `certs` - the certificate chain
    `keystore` - the `KeyStore`
    `crls` - the certificate revocation list or `null`
    `calendar` - the date or `null` for the current date
  Returns:
    `null` if the certificate chain could be validade or a `Object[]{cert,error}` where `cert` is the failed certificate and `error` is the error message

### getIssuer

    private static DERObject getIssuer(byte[] enc)

  Get the "issuer" from the TBSCertificate bytes that are passed in

  Parameters:
    `enc` - a TBSCertificate in a byte array
  Returns:
    a DERObject

### getSubject

    private static DERObject getSubject(byte[] enc)

  Get the "subject" from the TBSCertificate bytes that are passed in

  Parameters:
    `enc` - A TBSCertificate in a byte array
  Returns:
    a DERObject

### getIssuerFields

    public static PdfPKCS7.X509Name getIssuerFields(X509Certificate cert)

  Get the issuer fields from an X509 Certificate

  Parameters:
    `cert` - an X509Certificate
  Returns:
    an X509Name

### getSubjectFields

    public static PdfPKCS7.X509Name getSubjectFields(X509Certificate cert)

  Get the subject fields from an X509 Certificate

  Parameters:
    `cert` - an X509Certificate
  Returns:
    an X509Name

### getEncodedPKCS1

    public byte[] getEncodedPKCS1()

  Gets the bytes for the PKCS#1 object.

  Returns:
    a byte array

### setExternalDigest

    public void setExternalDigest(byte[] digest,
                                  byte[] RSAdata,
                                  String digestEncryptionAlgorithm)

  Sets the digest/signature to an external calculated value.

  Parameters:
    `digest` - the digest. This is the actual signature
    `RSAdata` - the extra data that goes into the data tag in PKCS#7
    `digestEncryptionAlgorithm` - the encryption algorithm. It may must be `null` if the `digest` is also `null`. If the `digest` is not `null` then it may be "RSA" or "DSA"

### getEncodedPKCS7

    public byte[] getEncodedPKCS7()

  Gets the bytes for the PKCS7SignedData object.

  Returns:
    the bytes for the PKCS7SignedData object

### getEncodedPKCS7

    public byte[] getEncodedPKCS7(byte[] secondDigest,
                                  Calendar signingTime)

  Gets the bytes for the PKCS7SignedData object. Optionally the authenticatedAttributes in the signerInfo can also be set. If either of the parameters is `null`, none will be used.

  Parameters:
    `secondDigest` - the digest in the authenticatedAttributes
    `signingTime` - the signing time in the authenticatedAttributes
  Returns:
    the bytes for the PKCS7SignedData object

### getAuthenticatedAttributeBytes

    public byte[] getAuthenticatedAttributeBytes(byte[] secondDigest,
                                                 Calendar signingTime)

  When using authenticatedAttributes the authentication process is different. The document digest is generated and put inside the attribute. The signing is done over the DER encoded authenticatedAttributes. This method provides that encoding and the parameters must be exactly the same as in `getEncodedPKCS7(byte[],Calendar)`.

  A simple example:

       Calendar cal = Calendar.getInstance();
       PdfPKCS7 pk7 = new PdfPKCS7(key, chain, null, "SHA1", null, false);
       MessageDigest messageDigest = MessageDigest.getInstance("SHA1");
       byte buf[] = new byte[8192];
       int n;
       InputStream inp = sap.getRangeStream();
       while ((n = inp.read(buf)) > 0) {
          messageDigest.update(buf, 0, n);
       }
       byte hash[] = messageDigest.digest();
       byte sh[] = pk7.getAuthenticatedAttributeBytes(hash, cal);
       pk7.update(sh, 0, sh.length);
       byte sg[] = pk7.getEncodedPKCS7(hash, cal);

  Parameters:
    `secondDigest` - the content digest
    `signingTime` - the signing time
  Returns:
    the byte array representation of the authenticatedAttributes ready to be signed

### getReason

    public String getReason()

  Getter for property reason.

  Returns:
    Value of property reason.

### setReason

    public void setReason(String reason)

  Setter for property reason.

  Parameters:
    `reason` - New value of property reason.

### getLocation

    public String getLocation()

  Getter for property location.

  Returns:
    Value of property location.

### setLocation

    public void setLocation(String location)

  Setter for property location.

  Parameters:
    `location` - New value of property location.

### getSignDate

    public Calendar getSignDate()

  Getter for property signDate.

  Returns:
    Value of property signDate.

### setSignDate

    public void setSignDate(Calendar signDate)

  Setter for property signDate.

  Parameters:
    `signDate` - New value of property signDate.

### getSignName

    public String getSignName()

  Getter for property sigName.

  Returns:
    Value of property sigName.

### setSignName

    public void setSignName(String signName)

  Setter for property sigName.

  Parameters:
    `signName` - New value of property sigName.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD